.rule defaults:
  conditions:
    - &is_main $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - &is_release $CI_COMMIT_TAG =~ /^v(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(?:-((?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\.(?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?$/i
    - &not_release $CI_COMMIT_TAG !~ /^v(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(?:-((?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\.(?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?$/i

.rules_dev:
  rules:
    - if: *is_main
    - if: *not_release

.rules_main:
  rules:
    - if: *is_main

.rules_release:
  rules:
    - if: *is_release

.rules_manual:
  rules:
    - if: *is_main
    - when: manual
      allow_failure: true

.rules_manual_allow_failure:
  rules:
    - if: *is_main
      allow_failure: true
    - when: manual
      allow_failure: true

.rules_dev_manual:
  rules:
    - if: *is_main
    - if: *not_release
      when: manual
      allow_failure: true

.rules_not_release_or_main:
  rules:
    - if: *is_main
      when: never
    - if: *not_release

.rules_not_release_or_main_manual:
  rules:
    - if: *is_main
      when: never
    - if: *not_release
      when: manual
      allow_failure: true

.rules_dev_allowfailure:
  rules:
    - if: *is_main
      allow_failure: true
    - if: *not_release
      allow_failure: true

.rules_release_allowfailure:
  rules:
    - if: *is_release
      allow_failure: true

.rules_connector_dev:
  rules:
    - if: '$PUBLISH_CONNECTOR == null'
      when: never
    - if: *is_main
    - if: *not_release

.rules_connector_dev_manual:
  rules:
    - if: '$PUBLISH_CONNECTOR == null'
      when: never
    - if: *is_main
    - if: *not_release
      when: manual
      allow_failure: true

.rules_connector_release:
  rules:
    - if: '$PUBLISH_CONNECTOR == null'
      when: never
    - if: *is_release

.rules_nuget_release:
  rules:
    - if: '$PUBLISH_NUGETORG == null'
      when: never
    - if: *is_release

# Backwards compatibility

.rules_master:
  rules:
    - if: *is_main

.rules_not_release_or_master:
  rules:
    - if: *is_main
      when: never
    - if: *not_release

.rules_not_release_or_master_manual:
  rules:
    - if: *is_main
      when: never
    - if: *not_release
      when: manual
      allow_failure: true
